# # sample index page with internationalization (T)
def index():
    redirect(URL(r=request,f='listes',args=['all']))
    return dict()
    
def aide():
    return dict(message="ici une page d'aide...")
    
def result_schulze():
    ### Procède au dépouillement du vote selon la méthode de Schulze
    resultat={}
    Q_id=request.args[0]
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    
    #Récupération des réponses et leurs index 
    les_Reponses=[]
    num_reponses=[]
    for r in db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        les_Reponses.append(r.titre)
        num_reponses.append(str(r.id))
        
    resultat=traduit_result(resultat,num_reponses)
    num=[str(elem) for elem in range(1,len(num_reponses)+1)]
    
    PD={}
    for i in num:
        for j in num:
            if i != j:
                ij=i+'>'+j
                ji=j+'>'+i
                PD[ij]=resultat.get(ij,0)-resultat.get(ji,0)
                
    for i in num:
        for j in num:
            if i != j:
                for k in num:
                    if i != k and j != k:
                        jk=j+'>'+k
                        ji=j+'>'+i
                        ik=i+'>'+k
                        PD[jk]=max(PD[jk],min(PD[ji],PD[ik]))
    winner=[]
                        
    for i in num:
        winner.append(i)
    for i in num:
        for j in num:
            if i != j:
                ji=j+'>'+i
                ij=i+'>'+j
                if PD[ji] > PD[ij] and i in winner:
                    del(winner[winner.index(i)])
                  
    return dict(Q=la_Q.description,R=les_Reponses,resultat=resultat,winner=winner)
                    
    
def result_popup():
    ### Procède au dépouillement du vote selon la méthodologie décrite dans la constitution Debian
    resultat={}
    liste_tuples=[]
    
    V_direct={}
    V_trans={}
    Q_id=request.args[0]
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    
    #Récupération des réponses et leurs index 
    les_Reponses=[]
    num_reponses=[]
    for r in db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        les_Reponses.append(r.titre)
        num_reponses.append(str(r.id))
        
    resultat=traduit_result(resultat,num_reponses)
    
    #Recherche des victoires directes=> dictionnaire V_direct={Vainqueur:[liste des vaincus,...]}
    for clef in resultat:
        R=clef.split('>')
        A,B=R[0],R[1]
        anti_clef=B+'>'+A
        if resultat[clef]>resultat.get(anti_clef,0):
            #delta=resultat[clef]-resultat.get(anti_clef,0)
            if V_direct.has_key(A):
                V_direct[A].append(B)
            else:
                V_direct[A]=[B]
                
    #Recherche des victoires transitives                
    for V in V_direct:            #V=Vainqueur
        for P in V_direct[V]:     #P=Perdant(s) face à V
            #P est dans V_direct
            if V_direct.has_key(P):
                if V_trans.has_key(V):
                    V_trans[V].append(P)
                else:
                    V_trans[V]=[P]
                #Héritage des victoires du perdant 
                for H in V_direct[P]:
                    if V_direct.has_key(H) and H not in V_trans[V]:
                        V_trans[V].append(H)
                        
    #Construction de l'ensemble de Schwartz 
    schwartz=[]
    for V1 in V_trans:
        for V2 in V_trans:
            #V1 est dans l'ensemble si: bat transitivement V2 ou n'est pas batu par V2
            if V2 in V_trans[V1] or V1 not in V_trans[V2]:
                if V1 != V2:
                    schwartz.append(V1)
                           
    #if V_trans=={}:
    #    V_trans=V_direct    
                
    #for A in V_direct[:len(Vdirect)-1]:
    #    for B in V_direct[V_direct.index(A)+1:]:
    #        clef=A+'>'+B
    #        anti_clef=B+'>'+A
    #        if resultat[clef]>resultat[anti_clef]:        
    #for clef in resultat:
    #    t=(resultat[clef],clef)
    #    liste_tuples.append(t)
    #liste_tuples.sort()
    #liste_tuples.reverse()
        
    return dict(Q=la_Q.description,R=les_Reponses,resultat=resultat,V_direct=V_direct,V_trans=V_trans,schwartz=schwartz)

def traduit_result(resultat,num_reponses):
    #traduit des résultats de type {'23>25':12,..} en {'1>3':12,..}
    new_resultat={}
    for clef in resultat:        
        R=clef.split('>')
        new_clef=str(num_reponses.index(R[0])+1)+'>'+str(num_reponses.index(R[1])+1)
        new_resultat[new_clef]=resultat[clef]
    return new_resultat    
                
    
@auth.requires_login()
def vote():
    #si le vote n'est pas valide (bulletin créé en Question X et voté en Question Y..(avec plusieurs questions ouvertes))
    if request.args[0]!=session.q:
        session.flash="vote NON VALIDE ! vous devez voter dans la zone du dernier bulletin préparé"
        redirect(URL(r=request,f="listes"))
    
    #si le vote est valide    
    bulletin=''.join(session.v)
    old_vote=(db.Votes.U_id==auth.user.id)&(db.Votes.Q_id==request.args[0])
    
    #si ancien vote existant
    if len(db(old_vote).select())>0:
        for v in db(old_vote).select():          
            old_bulletin=v.Buletin                                          
            old_matchs=matching(request.args[0],old_bulletin,v.date_vote)
            
        db(old_vote).update(D_id='',
                            Buletin=bulletin,
                            date_vote=request.now)
                            
        matchs=matching(request.args[0],bulletin,request.now)
        update_resultat(request.args[0],matchs,old_matchs)
        session.flash="Votre vote a été mis à jour...%s  pour %s  ..%s" %(bulletin,session.q,request.args[0])
    #si pas d'ancien vote    
    else:
        vote_id=db.Votes.insert(Q_id=request.args[0],
                                U_id=auth.user.id,D_id='',
                                Buletin=bulletin,
                                date_vote=request.now)
        la_Q=db(db.Questions.id==request.args[0]).select()[0] 
        matchs=matching(request.args[0],bulletin,request.now)                       
        db(db.Questions.id==request.args[0]).update(nbr_votes=la_Q.nbr_votes+1)
        update_resultat(request.args[0],matchs)
        
        session.flash="Votre vote a été enregistré..." 
    redirect(URL(r=request,f="listes"))
    return dict()
    
def str_to_dict(chaine):
    dico={}
    if chaine==None or chaine=='{}':
        return dico
    chaine=chaine.replace(' ','')
    chaine=chaine.replace('{','')
    chaine=chaine.replace('}','')
    chaine=chaine.replace("'",'')
    liste=chaine.split(',')
    for elem in liste:
        l_e=elem.split(':')
        dico[l_e[0]]=int(l_e[1])
    return dico
    
def update_resultat(Q_id,matchs,old_matchs=[]):
    resultat={}
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    old_resultat=resultat.copy()
    #on décrémente les anciens matchs
    for m in old_matchs:
        resultat[m]=resultat[m]-1
    #on incrémente les nouveaux matchs    
    for m in matchs:
        try:
            resultat[m]+=1
        except:
            resultat[m]=1
        
    db(db.Questions.id==Q_id).update(resultat=resultat)
    #session.flash="matchs... %s vers %s  ** resultat...%s  vers %s" %(old_matchs,matchs,old_resultat,resultat)
    
def matching(Q_id,bulletin,date_vote):
    matchs=[]
    liste_rns=[]
    #liste des réponses sélectionnées
    liste=bulletin.split('_')[1:]
    
    #liste des réponses non sélectionnées
    #prise en compte de la date pour les mises à jour (pour ne pas annuler un match sur question inexistante au temps du vote...)
    for j in  db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        if str(j.id) not in liste and j.date_postee<=date_vote:
            liste_rns.append(str(j.id))
        
    liste_b=liste+liste_rns
    for r in liste:
        for r2 in liste_b[liste_b.index(r)+1:]:
            couple=r+'>'+r2
            matchs.append(couple)
    return matchs
    
@auth.requires_login()    
def new_Q():
    form=SQLFORM(db.Questions)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Question prise en compte.."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
@auth.requires_login()
def new_R():
    db.Reponses.Q_id.default=request.args[0]
    form=SQLFORM(db.Reponses)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Réponse prise en compte.."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
@auth.requires_login()  #membership('Administrateurs')
def new_T():
    form=SQLFORM(db.Tags,fields=['titre'])
    if form.accepts(request.vars,session):
        session.flash="Nouveau Tag créé..."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)

@auth.requires_login()
def add_T():
    message=''
    existe=0
    db.Tags_Questions.Q_id.default=request.args[0]
    form=SQLFORM(db.Tags_Questions)
    if form.accepts(request.vars,session):
        for Tnum in db(db.Tags_Questions.Q_id==request.args[0]).select(db.Tags_Questions.ALL):
            if str(Tnum.T_id)==form.vars.T_id:
                existe+=1
                if existe>1:
                    db(db.Tags_Questions.id==form.vars.id).delete()
                    message="existait déjà"
        session.flash="Nouveau Tag pris en compte...%s" %message
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
def listes():
    if request.args:
        session.tag=request.args[0]
         
    if session.tag=='all':        
        questions=db().select(db.Questions.ALL)
    else:
        questions=db((db.Tags_Questions.T_id==session.tag)&(db.Tags_Questions.Q_id==db.Questions.id)).select(db.Questions.ALL)
        #session.flash="Tag actif...%s  Questions %s" %(tag_actif,questions)
        #questions=db().select(db.Questions.ALL)
        
    return dict(questions=questions)

def data():
    #Utilisée pour la mise à jour de la liste des réponses sélectionnées (Ajax)
    if not session.m:session.m=[]
    if not session.v:session.v=[]
    for clef in request.vars:
        if 'champ' in clef:
            q=clef[5:clef.find('_')]
            if not session.q or session.q!=q:
                session.m=[]
                session.v=[]
                session.q=q
            r=clef[clef.find('_'):]
            if request.vars[clef] in session.m:
                idx=session.m.index(request.vars[clef])
                del(session.m[idx])
                del(session.v[idx])
            session.m.append(request.vars[clef])
            session.v.append(r)
    return TABLE(*[TR(v) for v in session.m]).xml()

def clear_target():
    #Nettoyage de la Zone "target" d'affichage des réponses sélectionnées
    session.m=[]
    session.v=[]
    
    return TABLE(*[TR(v) for v in session.m]).xml()
           
        
# # uncomment the following if you have defined "auth" and "crud" in models
def user(): return dict(form=auth())
# def data(): return dict(form=crud())
# def download(): return response.download(request,db)
# # tip: use @auth.requires_login, requires_membership, requires_permission